unit SegArc;

interface

uses
{$IFDEF WIN32}
  Windows,
{$ELSE}
  WinTypes, WinProcs,
{$ENDIF}
  Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, Compress, Segment, Menus;

type
  TSegArcForm = class(TForm)
    Label1: TLabel;
    SeqLabel: TLabel;
    Label2: TLabel;
    TempLabel: TLabel;
    LBGroup: TGroupBox;
    LB: TListBox;
    CloseBtn: TBitBtn;
    TheCnt: TLabel;
    Label3: TLabel;
    TheMode: TLabel;
    LBMenu: TPopupMenu;
    PMDel: TMenuItem;
    PMView: TMenuItem;
    PMTarget: TMenuItem;
    procedure LBKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure LBMenuPopup(Sender: TObject);
    procedure PMDelClick(Sender: TObject);
    procedure PMViewClick(Sender: TObject);
    procedure PMTargetClick(Sender: TObject);
  private
    { Private declarations }
    procedure DeleteListBoxItems;
    procedure TheCount;
  public
    { Public declarations }
    procedure ViewEntry( const SArc: TSegArc );
    procedure EntryPoint( const SArc: TSegArc );
  end;

var
  SegArcForm: TSegArcForm;

implementation

uses Main, Common;

{$R *.DFM}

{===============================================================}
{===============================================================}
procedure TSegArcForm.TheCount;
begin
     TheCnt.Caption := 'Count: ' + IntToStr(LB.Items.Count);
     TheCnt.Update;
end;

{===============================================================}
{===============================================================}
procedure TSegArcForm.ViewEntry( const SArc: TSegArc );
var
   i:     Integer;
begin
     SeqLabel.Caption := IntToStr(SArc.SeqNumber);
     if (SArc.Mode = bmFlat) then
       TheMode.Caption := 'Flat'
     else
       TheMode.Caption := 'Recursive';
     TempLabel.Caption := SArc.Template;
     LB.PopupMenu := nil;
     LB.OnKeyDown := nil;
     LB.Clear;
     LBGroup.Caption := SArc.Target;
     for i := 0 to SArc.SL.Count-1 do
       LB.Items.Add(SArc.SL[i]);
     TheCount;
     ActiveControl := CloseBtn;
     ShowModal;
     if (LB.Items.Count < SArc.SL.Count) then
       begin
       SArc.SL.Clear;
       for i := 0 to LB.Items.Count-1 do
         SArc.SL.Add(LB.Items[i]);
       end;
end;

{===============================================================}
{===============================================================}
procedure TSegArcForm.EntryPoint( const SArc: TSegArc );
var
   i:     Integer;
begin
     SeqLabel.Caption := IntToStr(SArc.SeqNumber);
     if (SArc.Mode = bmFlat) then
       TheMode.Caption := 'Flat'
     else
       TheMode.Caption := 'Recursive';
     TempLabel.Caption := SArc.Template;
     LB.OnKeyDown := LBKeyDown;
     LB.PopupMenu := LBMenu;
     LB.Clear;
     LBGroup.Caption := SArc.Target;
     for i := 0 to SArc.SL.Count-1 do
       LB.Items.Add(SArc.SL[i]);
     TheCount;
     ActiveControl := CloseBtn;
     ShowModal;
     if (LB.Items.Count < SArc.SL.Count) then
       begin
       SArc.SL.Clear;
       for i := 0 to LB.Items.Count-1 do
         SArc.SL.Add(LB.Items[i]);
       end;
end;

{===============================================================}
{===============================================================}
procedure TSegArcForm.LBKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
     if (Key = VK_DELETE) then
       DeleteListBoxItems;
end;

{===============================================================}
{===============================================================}
procedure TSegArcForm.DeleteListBoxItems;
var
   i:      Integer;
begin
     while (LB.SelCount > 0) do
       begin
       for i := 0 to LB.Items.Count-1 do
         begin
         if (LB.Selected[i]) then
           begin
           LB.Items.Delete(i);
           TheCount;
           break;
           end;
         end;
       end;
end;

{===============================================================}
{===============================================================}
procedure TSegArcForm.LBMenuPopup(Sender: TObject);
var
  State:    Boolean;
begin
     with LBMenu do
       begin
       State := False;
       if ((LB.Items.Count > 0) and (LB.SelCount > 0)) then
         State := True;
       PMDel.Enabled := State;
       PMView.Enabled := State;
       PMTarget.Enabled := State;
       end;
end;

{===============================================================}
{===============================================================}
procedure TSegArcForm.PMDelClick(Sender: TObject);
begin
     if (LB.SelCount > 0) then
       DeleteListBoxItems;
end;

{===============================================================}
{===============================================================}
procedure TSegArcForm.PMViewClick(Sender: TObject);
var
  SArc:    TSegArc;
begin
     with MainForm.SegCompEZ do
       begin
       SArc := TSegArc(SegArcList.Lookup(LB.Items[LB.ItemIndex]));
       SegArcForm.EntryPoint(SArc);
       if (SArc.SL.Count = 0) then
         begin
         SegArcList.Remove(SArc);
         SArc.Free;
         LB.Items.Delete(LB.ItemIndex);
         TheCount;
         if (LB.Items.Count = 0) then
           LB.OnDblClick := nil;
         end;
       end;
end;

{===============================================================}
{===============================================================}
procedure TSegArcForm.PMTargetClick(Sender: TObject);
var
  NewTarget:        String;
  SArc:             TSegArc;
begin
     SArc := MainForm.SegCompEZ.GetSegArc(LB.ItemIndex);
     NewTarget := SArc.Target;
     NewTarget := InputBox('Change Target','New Target',NewTarget);
     if (NewTarget <> '') then
       SArc.Target := MakeTarget(NewTarget);
end;

end.
